
##############################################################################
#
# Copyright (c) 2005-2006 Balazs Ree <ree@greenfinity.hu> All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

'''\
Follow link
'''

from base import Action

class LinkAction(Action):
    'Open as click on link'

    def __init__(self, link, links):
        self.link = link
        # find all links with the same text 
        self.links_with_same_text = [l for l in links if l.text == link.text]

    def generate_set(self, writer):
        pass
        
    def generate_submit(self, writer):
        writer.write('page = %s.follow_link(text="%s"' % (writer.browservar, self.link.text))
        if len(self.links_with_same_text) > 1:
            # if there are more links with this text: add url
            writer.write(', url=')
            self.gen_urlpath(writer, self.link.url) 
            writer.write(')')
        else:
            # if there is only one: put text into comment.
            writer.write(') # url=')
            self.gen_urlpath(writer, self.link.url) 
        writer.newline()
