
##############################################################################
#
# Copyright (c) 2005-2006 Balazs Ree <ree@greenfinity.hu> All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

'''\
Open URL
'''

from base import Action

class OpenAction(Action):
    'Fallback: open it with full url and data'

    def __init__(self, data, encoded_form):
        self.data = data
        self.encoded_form = encoded_form

    def generate_set(self, writer):
        if self.encoded_form:
            writer.write('encoded_form = %s' % (repr(self.encoded_form), ))
            writer.newline()
            
    def generate_submit(self, writer):
        writer.write('page = %s.open(' % (writer.browservar, ))
        self.gen_urlpath(writer, self.data.environ['PATH_INFO'])
        if self.encoded_form:
            writer.write(', data=urlencode(encoded_form))')
        else:
            writer.write(')')
        writer.newline()
