
import unittest
from Products.mechagen.generator.utils import lazy

class TestLazy(unittest.TestCase):
    'Test lazy descriptor'
    
    def test_basic(self):
        'lazy descriptor base functionality'

        class LazyTestClass(object):

            def _gen1(self):
                return 1

            def _gen2(self):
                return 2, 3

            f = lazy(_gen1)
            
            g1, g2 = lazy(_gen2, 2)

        c = LazyTestClass()

        self.assertEqual(c.f, 1)
        self.assertEqual(c.g1, 2)
        self.assertEqual(c.g2, 3)

        self.assertEqual(c.f, 1)
        self.assertEqual(c.g1, 2)
        self.assertEqual(c.g2, 3)

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestLazy))
    return suite
